/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.79 Revision 1.115
1# Copyright 1999-2010 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.79 2010/12/06 10:17:04 tampakrap Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.115 2012/05/02 18:31:42 jdhore Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.X ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The kde4-base.eclass provides support for building KDE4 based ebuilds 10# The kde4-base.eclass provides support for building KDE4 based ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: KDE 4 ebuilds by default define EAPI="2", this can be redefined but 13# NOTE: KDE 4 ebuilds currently support EAPI "3". This will be reviewed
14# eclass will fail with version older than 2. 14# over time as new EAPI versions are approved.
15
16# @ECLASS-VARIABLE: KDE_SELINUX_MODULE
17# @DESCRIPTION:
18# If set to "none", do nothing.
19# For any other value, add selinux to IUSE, and depending on that useflag
20# add a dependency on sec-policy/selinux-${KDE_SELINUX_MODULE} to (R)DEPEND
21: ${KDE_SELINUX_MODULE:=none}
15 22
16# @ECLASS-VARIABLE: VIRTUALX_REQUIRED 23# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
17# @DESCRIPTION: 24# @DESCRIPTION:
18# Do we need an X server? Valid values are "always", "optional", and "manual". 25# For proper description see virtualx.eclass manpage.
19# "tests" is a synonym for "optional". While virtualx.eclass supports in principle 26# Here we redefine default value to be manual, if your package needs virtualx
20# also the use of an X server during other ebuild phases, we only use it in 27# for tests you should proceed with setting VIRTUALX_REQUIRED=test.
21# src_test here. Most likely you'll want to set "optional", which introduces the
22# use-flag "test" (if not already present), adds dependencies conditional on that
23# use-flag, and automatically runs (only) the ebuild test phase with a virtual X server
24# present. This makes things a lot more comfortable than the bare virtualx eclass.
25
26# In case the variable is not set in the ebuild, let virtualx eclass not do anything
27: ${VIRTUALX_REQUIRED:=manual} 28: ${VIRTUALX_REQUIRED:=manual}
28 29
29inherit kde4-functions base virtualx eutils 30inherit kde4-functions toolchain-funcs fdo-mime gnome2-utils base virtualx versionator eutils
30 31
31get_build_type
32if [[ ${BUILD_TYPE} = live ]]; then 32if [[ ${BUILD_TYPE} = live ]]; then
33 if [[ ${KDEBASE} = kdevelop ]]; then 33 case ${KDE_SCM} in
34 inherit git
35 else
36 inherit subversion 34 svn) inherit subversion ;;
37 fi 35 git) inherit git-2 ;;
36 esac
38fi 37fi
39 38
40# @ECLASS-VARIABLE: CMAKE_REQUIRED 39# @ECLASS-VARIABLE: CMAKE_REQUIRED
41# @DESCRIPTION: 40# @DESCRIPTION:
42# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'. 41# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'.
47if [[ ${CMAKE_REQUIRED} = always ]]; then 46if [[ ${CMAKE_REQUIRED} = always ]]; then
48 buildsystem_eclass="cmake-utils" 47 buildsystem_eclass="cmake-utils"
49 export_fns="src_configure src_compile src_test src_install" 48 export_fns="src_configure src_compile src_test src_install"
50fi 49fi
51 50
52# Verify KDE_MINIMAL (display QA notice in pkg_setup, still we need to fix it here)
53if [[ -n ${KDE_MINIMAL} ]]; then
54 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
55 [[ ${KDE_MINIMAL} = ${slot} ]] && KDE_MINIMAL_VALID=1 && break
56 done
57 unset slot
58 [[ -z ${KDE_MINIMAL_VALID} ]] && unset KDE_MINIMAL
59else
60 KDE_MINIMAL_VALID=1
61fi
62
63# @ECLASS-VARIABLE: KDE_MINIMAL 51# @ECLASS-VARIABLE: KDE_MINIMAL
64# @DESCRIPTION: 52# @DESCRIPTION:
65# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal 53# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
66# version for apps to work. Currently defaults to 4.4 54# version for apps to work. Currently defaults to 4.4
67# One may override this variable to raise version requirements. 55# One may override this variable to raise version requirements.
68# For possible values look at KDE_SLOTS and KDE_LIVE_SLOTS variables.
69# Note that it is fixed to ${SLOT} for kde-base packages. 56# Note that it is fixed to ${PV} for kde-base packages.
70KDE_MINIMAL="${KDE_MINIMAL:-4.4}" 57KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
71 58
72# Set slot for packages in kde-base, koffice and kdevelop 59# Set slot for KDEBASE known packages
73case ${KDEBASE} in 60case ${KDEBASE} in
74 kde-base) 61 kde-base)
75 # Determine SLOT from PVs 62 SLOT=4
76 case ${PV} in
77 *.9999*) SLOT="${PV/.9999*/}" ;; # stable live
78 4.6* | 4.5.[6-9][0-9]*) SLOT="4.6" ;;
79 4.5* | 4.4.[6-9][0-9]*) SLOT="4.5" ;;
80 4.4* | 4.3.[6-9][0-9]*) SLOT="4.4" ;;
81 9999*) SLOT="live" ;; # regular live
82 *) die "Unsupported ${PV}" ;;
83 esac
84 KDE_MINIMAL="${SLOT}" 63 KDE_MINIMAL="${PV}"
85 ;; 64 ;;
86 koffice) 65 koffice)
87 SLOT="2" 66 SLOT="2"
88 ;; 67 ;;
89 kdevelop) 68 kdevelop)
102 case ${PN} in 81 case ${PN} in
103 kdevelop|quanta) 82 kdevelop|quanta)
104 KDEVELOP_VERSION=${PV} 83 KDEVELOP_VERSION=${PV}
105 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)" 84 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
106 ;; 85 ;;
107 kdevplatform) 86 kdevplatform|kdevelop-php*)
108 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)" 87 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
109 KDEVPLATFORM_VERSION=${PV} 88 KDEVPLATFORM_VERSION=${PV}
110 ;; 89 ;;
111 *) 90 *)
112 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}" 91 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
115 fi 94 fi
116 SLOT="4" 95 SLOT="4"
117 ;; 96 ;;
118esac 97esac
119 98
120slot_is_at_least 4.5 ${KDE_MINIMAL} && CMAKE_MIN_VERSION="2.8.1"
121
122inherit ${buildsystem_eclass} 99inherit ${buildsystem_eclass}
123 100
124EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_postinst pkg_postrm 101EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_preinst pkg_postinst pkg_postrm
125 102
126unset buildsystem_eclass 103unset buildsystem_eclass
127unset export_fns 104unset export_fns
128 105
129# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED 106# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
147# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED 124# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
148# @DESCRIPTION: 125# @DESCRIPTION:
149# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'. 126# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'.
150# This variable must be set before inheriting any eclasses. Defaults to 'never'. 127# This variable must be set before inheriting any eclasses. Defaults to 'never'.
151MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}" 128MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
152
153# @ECLASS-VARIABLE: WEBKIT_REQUIRED
154# @DESCRIPTION:
155# Is qt-webkit requred? Possible values are 'always', 'optional' and 'never'.
156# This variable must be set before inheriting any eclasses. Defaults to 'never'.
157WEBKIT_REQUIRED="${WEBKIT_REQUIRED:-never}"
158 129
159# @ECLASS-VARIABLE: CPPUNIT_REQUIRED 130# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
160# @DESCRIPTION: 131# @DESCRIPTION:
161# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'. 132# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
162# This variable must be set before inheriting any eclasses. Defaults to 'never'. 133# This variable must be set before inheriting any eclasses. Defaults to 'never'.
176# (handbook USE flag) and 'never'. 147# (handbook USE flag) and 'never'.
177# This variable must be set before inheriting any eclasses. Defaults to 'never'. 148# This variable must be set before inheriting any eclasses. Defaults to 'never'.
178# It adds default handbook dirs for kde-base packages to KMEXTRA and in any case it 149# It adds default handbook dirs for kde-base packages to KMEXTRA and in any case it
179# ensures buildtime and runtime dependencies. 150# ensures buildtime and runtime dependencies.
180KDE_HANDBOOK="${KDE_HANDBOOK:-never}" 151KDE_HANDBOOK="${KDE_HANDBOOK:-never}"
152
153# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE
154# @DESCRIPTION:
155# Set this varible if you want your live package to manage its
156# translations. (Mostly all kde ebuilds does not ship documentation
157# and translations in live ebuilds)
158if [[ ${BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then
159 # Kdebase actualy provides the handbooks even for live stuff
160 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never
161 KDE_LINGUAS=""
162fi
181 163
182# Setup packages inheriting this eclass 164# Setup packages inheriting this eclass
183case ${KDEBASE} in 165case ${KDEBASE} in
184 kde-base) 166 kde-base)
185 HOMEPAGE="http://www.kde.org/" 167 HOMEPAGE="http://www.kde.org/"
186 LICENSE="GPL-2" 168 LICENSE="GPL-2"
187 if [[ $BUILD_TYPE = live ]]; then 169 if [[ $BUILD_TYPE = live ]]; then
188 # Disable tests for live ebuilds 170 # Disable tests for live ebuilds
189 RESTRICT+=" test" 171 RESTRICT+=" test"
190 # Live ebuilds in kde-base default to kdeprefix by default 172 fi
191 IUSE+=" +kdeprefix" 173
192 else 174 # Only add the kdeprefix USE flag for older versions, to help
193 # All other ebuild types default to -kdeprefix as before 175 # non-portage package managers handle the upgrade
176 if [[ ${PV} < 4.6.4 && ( ( ${KMNAME} != kdepim && ${PN} != kdepim-runtime ) || ${PV} < 4.6 ) ]]; then
194 IUSE+=" kdeprefix" 177 IUSE+=" kdeprefix"
195 fi 178 fi
179
196 # This code is to prevent portage from searching GENTOO_MIRRORS for 180 # This code is to prevent portage from searching GENTOO_MIRRORS for
197 # packages that will never be mirrored. (As they only will ever be in 181 # packages that will never be mirrored. (As they only will ever be in
198 # the overlay). 182 # the overlay).
199 case ${PV} in 183 case ${PV} in
200 *9999* | 4.?.[6-9]?) 184 *9999* | 4.?.[6-9]?)
201 RESTRICT+=" mirror" 185 RESTRICT+=" mirror"
202 ;; 186 ;;
203 esac 187 esac
204 # Block installation of other SLOTS unless kdeprefix
205 RDEPEND+=" $(block_other_slots)"
206 ;; 188 ;;
207 koffice) 189 koffice)
208 HOMEPAGE="http://www.koffice.org/" 190 HOMEPAGE="http://www.koffice.org/"
209 LICENSE="GPL-2" 191 LICENSE="GPL-2"
210 ;; 192 ;;
214 ;; 196 ;;
215esac 197esac
216 198
217# @ECLASS-VARIABLE: QT_MINIMAL 199# @ECLASS-VARIABLE: QT_MINIMAL
218# @DESCRIPTION: 200# @DESCRIPTION:
219# Determine version of qt we enforce as minimal for the package. 4.4.0 4.5.1... 201# Determine version of qt we enforce as minimal for the package.
220# 4.6.0 for 4.4, 4.6.3 for 4.5, and 4.7.0 for 4.6 and later
221if slot_is_at_least 4.6 "${KDE_MINIMAL}"; then 202if version_is_at_least 4.8.50 "${KDE_MINIMAL}"; then
203 # Upstream has added an *undeclared* dependency on Qt 4.8...
204 QT_MINIMAL="${QT_MINIMAL:-4.8.0}"
205elif version_is_at_least 4.7.80 "${KDE_MINIMAL}"; then
206 QT_MINIMAL="${QT_MINIMAL:-4.7.4}"
207else
222 QT_MINIMAL="${QT_MINIMAL:-4.7.0}" 208 QT_MINIMAL="${QT_MINIMAL:-4.7.0}"
223elif slot_is_at_least 4.5 "${KDE_MINIMAL}"; then
224 QT_MINIMAL="${QT_MINIMAL:-4.6.3}"
225else
226 QT_MINIMAL="${QT_MINIMAL:-4.6.0}"
227fi 209fi
228 210
229# Declarative dependencies 211# Declarative dependencies
230qtdeclarativedepend=" 212qtdeclarativedepend="
231 >=x11-libs/qt-declarative-${QT_MINIMAL}:4 213 >=x11-libs/qt-declarative-${QT_MINIMAL}:4
287 ;; 269 ;;
288 *) ;; 270 *) ;;
289esac 271esac
290unset qtmultimediadepend 272unset qtmultimediadepend
291 273
292# WebKit dependencies
293case ${KDE_REQUIRED} in
294 always)
295 qtwebkitusedeps="[kde]"
296 ;;
297 optional)
298 qtwebkitusedeps="[kde?]"
299 ;;
300 *) ;;
301esac
302qtwebkitdepend="
303 >=x11-libs/qt-webkit-${QT_MINIMAL}:4${qtwebkitusedeps}
304"
305unset qtwebkitusedeps
306case ${WEBKIT_REQUIRED} in
307 always)
308 COMMONDEPEND+=" ${qtwebkitdepend}"
309 ;;
310 optional)
311 IUSE+=" webkit"
312 COMMONDEPEND+=" webkit? ( ${qtwebkitdepend} )"
313 ;;
314 *) ;;
315esac
316unset qtwebkitdepend
317
318# CppUnit dependencies 274# CppUnit dependencies
319cppuintdepend=" 275cppuintdepend="
320 dev-util/cppunit 276 dev-util/cppunit
321" 277"
322case ${CPPUNIT_REQUIRED} in 278case ${CPPUNIT_REQUIRED} in
335# Qt accessibility classes are needed in various places, bug 325461 291# Qt accessibility classes are needed in various places, bug 325461
336kdecommondepend=" 292kdecommondepend="
337 dev-lang/perl 293 dev-lang/perl
338 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl] 294 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl]
339 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus] 295 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus]
340 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility,kde] 296 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility]
341 >=x11-libs/qt-script-${QT_MINIMAL}:4 297 >=x11-libs/qt-script-${QT_MINIMAL}:4
342 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support] 298 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support]
343 >=x11-libs/qt-svg-${QT_MINIMAL}:4 299 >=x11-libs/qt-svg-${QT_MINIMAL}:4
344 >=x11-libs/qt-test-${QT_MINIMAL}:4 300 >=x11-libs/qt-test-${QT_MINIMAL}:4
301 >=x11-libs/qt-webkit-${QT_MINIMAL}:4
345 !aqua? ( 302 !aqua? (
346 x11-libs/libXext 303 x11-libs/libXext
347 x11-libs/libXt 304 x11-libs/libXt
348 x11-libs/libXxf86vm 305 x11-libs/libXxf86vm
306 x11-libs/libXcomposite
307 x11-libs/libxkbfile
349 ) 308 )
350" 309"
351 310
352if [[ ${PN} != kdelibs ]]; then 311if [[ ${PN} != kdelibs ]]; then
353 kdecommondepend+=" $(add_kdebase_dep kdelibs)" 312 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
367 *) ;; 326 *) ;;
368 esac 327 esac
369 fi 328 fi
370 fi 329 fi
371fi 330fi
331
372kdedepend=" 332kdedepend="
373 dev-util/automoc 333 dev-util/automoc
374 dev-util/pkgconfig 334 virtual/pkgconfig
375 !aqua? ( 335 !aqua? (
376 || ( >=x11-libs/libXtst-1.1.0 <x11-proto/xextproto-7.1.0 ) 336 >=x11-libs/libXtst-1.1.0
377 x11-proto/xf86vidmodeproto 337 x11-proto/xf86vidmodeproto
378 ) 338 )
379" 339"
340
380kderdepend="" 341kderdepend=""
342
343# all packages needs oxygen icons for basic iconset
344if [[ ${PN} != oxygen-icons ]]; then
345 kderdepend+=" $(add_kdebase_dep oxygen-icons)"
346fi
347
348# add a dependency over kde-l10n if EAPI4 or better is around
349if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} && ${EAPI:-0} != 3 ]]; then
350 for _lingua in ${KDE_LINGUAS}; do
351 # if our package has lignuas, pull in kde-l10n with selected lingua enabled,
352 # but only for selected ones.
353 # this can't be done on one line because if user doesn't use any localisation
354 # then he is probably not interested in kde-l10n at all.
355 kderdepend+="
356 linguas_${_lingua}? ( $(add_kdebase_dep kde-l10n "linguas_${_lingua}(+)") )
357 "
358 done
359 unset _lingua
360fi
381 361
382kdehandbookdepend=" 362kdehandbookdepend="
383 app-text/docbook-xml-dtd:4.2 363 app-text/docbook-xml-dtd:4.2
384 app-text/docbook-xsl-stylesheets 364 app-text/docbook-xsl-stylesheets
385" 365"
398 ;; 378 ;;
399 *) ;; 379 *) ;;
400esac 380esac
401unset kdehandbookdepend kdehandbookrdepend 381unset kdehandbookdepend kdehandbookrdepend
402 382
383case ${KDE_SELINUX_MODULE} in
384 none) ;;
385 *)
386 IUSE+=" selinux"
387 kdecommondepend+=" selinux? ( sec-policy/selinux-${KDE_SELINUX_MODULE} )"
388 ;;
389esac
390
403case ${KDE_REQUIRED} in 391case ${KDE_REQUIRED} in
404 always) 392 always)
405 IUSE+=" aqua" 393 IUSE+=" aqua"
406 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}" 394 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
407 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}" 395 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
425# Accumulate dependencies set by this eclass 413# Accumulate dependencies set by this eclass
426DEPEND+=" ${COMMONDEPEND}" 414DEPEND+=" ${COMMONDEPEND}"
427RDEPEND+=" ${COMMONDEPEND}" 415RDEPEND+=" ${COMMONDEPEND}"
428unset COMMONDEPEND 416unset COMMONDEPEND
429 417
430# Add experimental kdeenablefinal, disabled by default
431IUSE+=" kdeenablefinal"
432
433# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a 418# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
434# koffice ebuild, the URI should be set in the ebuild itself 419# koffice ebuild, the URI should be set in the ebuild itself
435case ${BUILD_TYPE} in 420_calculate_src_uri() {
436 live) 421 debug-print-function ${FUNCNAME} "$@"
422
423 local _kmname _kmname_pv
424
425 # we calculate URI only for known KDEBASE modules
426 [[ -n ${KDEBASE} ]] || return
427
428 # calculate tarball module name
429 if [[ -n ${KMNAME} ]]; then
430 # fixup kdebase-apps name
431 case ${KMNAME} in
432 kdebase-apps)
433 _kmname="kdebase" ;;
434 *)
435 _kmname="${KMNAME}" ;;
436 esac
437 else
438 _kmname=${PN}
439 fi
440 _kmname_pv="${_kmname}-${PV}"
441 case ${KDEBASE} in
442 kde-base)
443 case ${PV} in
444 4.4.11.1)
445 # KDEPIM 4.4, special case
446 # TODO: Remove this part when KDEPIM 4.4 gets out of the tree
447 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2" ;;
448 4.[456789].8[05] | 4.[456789].9[0235678])
449 # Unstable KDE SC releases
450 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2" ;;
451 4.8.[12345])
452 # Stable KDE SC releases with .xz support
453 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.xz" ;;
454 *)
455 # Stable KDE SC releases
456 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2" ;;
457 esac
458 ;;
459 koffice)
460 case ${PV} in
461 2.[1234].[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
462 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
463 esac
464 ;;
465 kdevelop|kdevelop-php*|kdevplatform)
466 case ${KDEVELOP_VERSION} in
467 4.[12].[6-9]*) SRC_URI="mirror://kde/unstable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2" ;;
468 *) SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2" ;;
469 esac
470 ;;
471 esac
472}
473
474_calculate_live_repo() {
475 debug-print-function ${FUNCNAME} "$@"
476
437 SRC_URI="" 477 SRC_URI=""
438 if has subversion ${INHERITED}; then 478 case ${KDE_SCM} in
479 svn)
439 # Determine branch URL based on live type 480 # Determine branch URL based on live type
440 local branch_prefix 481 local branch_prefix
441 case ${PV} in 482 case ${PV} in
442 9999*) 483 9999*)
443 # trunk 484 # trunk
444 branch_prefix="trunk/KDE" 485 branch_prefix="trunk/KDE"
445 ;; 486 ;;
446 *) 487 *)
447 # branch 488 # branch
448 branch_prefix="branches/KDE/${SLOT}" 489 branch_prefix="branches/KDE/$(get_kde_version)"
449 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX 490 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
450 # @DESCRIPTION 491 # @DESCRIPTION
451 # Suffix appended to ESVN_PROJECT depending on fetched branch. 492 # Suffix appended to ESVN_PROJECT depending on fetched branch.
452 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise. 493 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
453 ESVN_PROJECT_SUFFIX="-${PV}" 494 ESVN_PROJECT_SUFFIX="-${PV}"
504 # @DESCRIPTION: 545 # @DESCRIPTION:
505 # This variable is used for specifying the timeout between svn synces 546 # This variable is used for specifying the timeout between svn synces
506 # for kde-base and koffice modules. Does not affect misc apps. 547 # for kde-base and koffice modules. Does not affect misc apps.
507 # Default value is 1 hour. 548 # Default value is 1 hour.
508 [[ ${KDEBASE} = kde-base || ${KDEBASE} = koffice ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1} 549 [[ ${KDEBASE} = kde-base || ${KDEBASE} = koffice ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
509 elif has git ${INHERITED}; then
510 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
511 KMMODULE="${PN}"
512 fi
513 case ${KDEBASE} in
514 kdevelop)
515 EGIT_REPO_URI="git://git.kde.org/${KMMODULE}"
516 ;;
517 esac
518 fi
519 ;; 550 ;;
520 *) 551 git)
552 local _kmname
553 # @ECLASS-VARIABLE: EGIT_MIRROR
554 # @DESCRIPTION:
555 # This variable allows easy overriding of default kde mirror service
556 # (anongit) with anything else you might want to use.
557 EGIT_MIRROR=${EGIT_MIRROR:=git://anongit.kde.org}
558
559 # @ECLASS-VARIABLE: EGIT_REPONAME
560 # @DESCRIPTION:
561 # This variable allows overriding of default repository
562 # name. Specify only if this differ from PN and KMNAME.
521 if [[ -n ${KDEBASE} ]]; then 563 if [[ -n ${EGIT_REPONAME} ]]; then
564 # the repository and kmname different
565 _kmname=${EGIT_REPONAME}
522 if [[ -n ${KMNAME} ]]; then 566 elif [[ -n ${KMNAME} ]]; then
523 case ${KMNAME} in
524 kdebase-apps)
525 _kmname="kdebase" ;;
526 *)
527 _kmname="${KMNAME}" ;; 567 _kmname=${KMNAME}
528 esac
529 else 568 else
530 _kmname=${PN} 569 _kmname=${PN}
531 fi 570 fi
532 _kmname_pv="${_kmname}-${PV}" 571
533 case ${KDEBASE} in 572 # default branching
534 kde-base) 573 [[ ${PV} != 9999* && ${KDEBASE} == kde-base ]] && \
535 case ${PV} in 574 EGIT_BRANCH="KDE/$(get_kde_version)"
536 4.[456].8[05] | 4.[456].9[023568]) 575
537 # Unstable KDE SC releases 576 # default repo uri
538 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2" 577 EGIT_REPO_URI="${EGIT_MIRROR}/${_kmname}"
539 ;; 578
540 4.4.6 | 4.4.7 | 4.4.8) 579 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
541 # Only kdepim here 580 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
542 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2"
543 ;;
544 *)
545 # Stable KDE SC releases
546 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2"
547 ;;
548 esac
549 ;;
550 koffice)
551 case ${PV} in
552 2.1.[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
553 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
554 esac
555 ;;
556 kdevelop)
557 SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2"
558 ;;
559 esac
560 unset _kmname _kmname_pv
561 fi
562 ;; 581 ;;
582 esac
583}
584
585case ${BUILD_TYPE} in
586 live) _calculate_live_repo ;;
587 *) _calculate_src_uri ;;
563esac 588esac
564 589
565debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}" 590debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
566 591
567# @ECLASS-VARIABLE: PREFIX 592# @ECLASS-VARIABLE: PREFIX
568# @DESCRIPTION: 593# @DESCRIPTION:
569# Set the installation PREFIX for non kde-base applications. It defaults to /usr. 594# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
570# kde-base packages go into KDE4 installation directory (KDEDIR) by default. 595# kde-base packages go into KDE4 installation directory (/usr).
571# No matter the PREFIX, package will be built against KDE installed in KDEDIR. 596# No matter the PREFIX, package will be built against KDE installed in /usr.
572 597
573# @FUNCTION: kde4-base_pkg_setup 598# @FUNCTION: kde4-base_pkg_setup
574# @DESCRIPTION: 599# @DESCRIPTION:
575# Do the basic kdeprefix KDEDIR settings and determine with which kde should 600# Do some basic settings
576# optional applications link
577kde4-base_pkg_setup() { 601kde4-base_pkg_setup() {
578 debug-print-function ${FUNCNAME} "$@" 602 debug-print-function ${FUNCNAME} "$@"
579 603
580 # Prefix compat: 604 if has handbook ${IUSE} || has "+handbook" ${IUSE} && [ "${KDE_HANDBOOK}" != optional ] ; then
581 if [[ ${EAPI} == 2 ]] && ! use prefix; then 605 eqawarn "Handbook support is enabled via KDE_HANDBOOK=optional in the ebuild."
582 EPREFIX= 606 eqawarn "Please do not just set IUSE=handbook, as this leads to dependency errors."
583 EROOT=${ROOT}
584 fi 607 fi
585 608
586 # Append missing trailing slash character 609 if use_if_iuse kdeprefix; then
587 [[ ${EROOT} = */ ]] || EROOT+="/" 610 eerror "Sorry, kdeprefix support has been removed."
611 eerror "Please remove kdeprefix from your USE variable."
612 die "kdeprefix support has been removed"
613 fi
588 614
589 # QA ebuilds 615 if [[ ${CATEGORY}/${PN} != kde-base/kdelibs && ${CATEGORY}/${PN} != kde-base/kde-env ]] && \
590 [[ -z ${KDE_MINIMAL_VALID} ]] && ewarn "QA Notice: ignoring invalid KDE_MINIMAL (defaulting to ${KDE_MINIMAL})." 616 { [[ ${KDE_REQUIRED} == always ]] || { [[ ${KDE_REQUIRED} == optional ]] && use kde; }; } && \
617 has_version kde-base/kdelibs[kdeprefix]; then
618 eerror "Sorry, kdeprefix support has been removed."
619 eerror "Please rebuild kdelibs without kdeprefix support."
620 die "kdeprefix support has been removed"
621 fi
591 622
592 # Don't set KDEHOME during compilation, it will cause access violations 623 # Don't set KDEHOME during compilation, it will cause access violations
593 unset KDEHOME 624 unset KDEHOME
594 625
595 if [[ ${KDEBASE} = kde-base ]]; then 626 # Check if gcc compiler is fresh enough.
596 if use kdeprefix; then 627 # In theory should be in pkg_pretend but we check it only for kdelibs there
597 KDEDIR=/usr/kde/${SLOT} 628 # and for others we do just quick scan in pkg_setup because pkg_pretend
598 else 629 # executions consume quite some time.
599 KDEDIR=/usr 630 # We can only do this for EAPI 4 or later because the MERGE_TYPE variable
631 # is otherwise undefined.
632 if [[ ${EAPI:-0} != 3 ]]; then
633 if [[ ${MERGE_TYPE} != binary ]]; then
634 [[ $(gcc-major-version) -lt 4 ]] || \
635 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 3 ]] ) \
636 && die "Sorry, but gcc-4.3 and earlier wont work for KDE (see bug 354837)."
600 fi 637 fi
601 : ${PREFIX:=${KDEDIR}}
602 else
603 # Determine KDEDIR by loooking for the closest match with KDE_MINIMAL
604 KDEDIR=
605 local kde_minimal_met
606 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
607 [[ -z ${kde_minimal_met} ]] && [[ ${slot} = ${KDE_MINIMAL} ]] && kde_minimal_met=1
608 if [[ -n ${kde_minimal_met} ]] && has_version "kde-base/kdelibs:${slot}"; then
609 if has_version "kde-base/kdelibs:${slot}[kdeprefix]"; then
610 KDEDIR=/usr/kde/${slot}
611 else
612 KDEDIR=/usr
613 fi
614 break;
615 fi
616 done
617 unset slot
618
619 # Bail out if kdelibs required but not found
620 if [[ ${KDE_REQUIRED} = always ]] || { [[ ${KDE_REQUIRED} = optional ]] && use kde; }; then
621 [[ -z ${KDEDIR} ]] && die "Failed to determine KDEDIR!"
622 else
623 [[ -z ${KDEDIR} ]] && KDEDIR=/usr
624 fi 638 fi
625 639
640 KDEDIR=/usr
626 : ${PREFIX:=/usr} 641 : ${PREFIX:=/usr}
627 fi 642 EKDEDIR=${EPREFIX}/usr
628 EKDEDIR=${EPREFIX}${KDEDIR}
629 643
630 # Point pkg-config path to KDE *.pc files
631 export PKG_CONFIG_PATH="${EKDEDIR}/$(get_libdir)/pkgconfig${PKG_CONFIG_PATH:+:${PKG_CONFIG_PATH}}"
632 # Point to correct QT plugins path 644 # Point to correct QT plugins path
633 QT_PLUGIN_PATH="${EKDEDIR}/$(get_libdir)/kde4/plugins/" 645 QT_PLUGIN_PATH="${EPREFIX}/usr/$(get_libdir)/kde4/plugins/"
634 646
635 # Fix XDG collision with sandbox 647 # Fix XDG collision with sandbox
636 export XDG_CONFIG_HOME="${T}" 648 export XDG_CONFIG_HOME="${T}"
637} 649}
638 650
641# This function unpacks the source tarballs for KDE4 applications. 653# This function unpacks the source tarballs for KDE4 applications.
642kde4-base_src_unpack() { 654kde4-base_src_unpack() {
643 debug-print-function ${FUNCNAME} "$@" 655 debug-print-function ${FUNCNAME} "$@"
644 656
645 if [[ ${BUILD_TYPE} = live ]]; then 657 if [[ ${BUILD_TYPE} = live ]]; then
646 if has subversion ${INHERITED}; then 658 case ${KDE_SCM} in
659 svn)
647 migrate_store_dir 660 migrate_store_dir
648 subversion_src_unpack 661 subversion_src_unpack
649 elif has git ${INHERITED}; then
650 git_src_unpack
651 fi
652 elif [[ ${EAPI} == 2 ]]; then
653 local file
654 for file in ${A}; do
655 # This setup is because EAPI <= 2 cannot unpack *.tar.xz files
656 # directly, so we do it ourselves (using the exact same code as portage)
657 case ${file} in
658 *.tar.xz)
659 echo ">>> Unpacking ${file} to ${PWD}"
660 xz -dc "${DISTDIR}"/${file} | tar xof -
661 assert "failed unpacking ${file}"
662 ;; 662 ;;
663 *) 663 git)
664 unpack ${file} 664 git-2_src_unpack
665 ;; 665 ;;
666 esac 666 esac
667 done
668 else 667 else
669 # For EAPI >= 3, we can just use unpack() directly
670 unpack ${A} 668 unpack ${A}
671 fi 669 fi
672} 670}
673 671
674# @FUNCTION: kde4-base_src_prepare 672# @FUNCTION: kde4-base_src_prepare
678# enable_selected_linguas() and enable_selected_doc_linguas() 676# enable_selected_linguas() and enable_selected_doc_linguas()
679# in kde4-functions.eclass(5) for further details. 677# in kde4-functions.eclass(5) for further details.
680kde4-base_src_prepare() { 678kde4-base_src_prepare() {
681 debug-print-function ${FUNCNAME} "$@" 679 debug-print-function ${FUNCNAME} "$@"
682 680
681 # enable handbook and linguas only when not using live ebuild
682
683 # Only enable selected languages, used for KDE extragear apps. 683 # Only enable selected languages, used for KDE extragear apps.
684 if [[ -n ${KDE_LINGUAS} ]]; then 684 if [[ -n ${KDE_LINGUAS} ]]; then
685 enable_selected_linguas 685 enable_selected_linguas
686 fi 686 fi
687 687
688 # Enable/disable handbooks for kde4-base packages 688 # Enable/disable handbooks for kde4-base packages
689 # kde-l10n inherits kde4-base but is metpackage, so no check for doc 689 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
690 # kdelibs inherits kde4-base but handle installing the handbook itself 690 # kdelibs inherits kde4-base but handle installing the handbook itself
691 if ! has kde4-meta ${INHERITED}; then 691 if ! has kde4-meta ${INHERITED} && in_iuse handbook; then
692 has handbook ${IUSE//+} && [[ ${PN} != kde-l10n ]] && [[ ${PN} != kdelibs ]] && enable_selected_doc_linguas 692 if [[ ${KDEBASE} == kde-base ]]; then
693 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
694 # documentation in kde4-functions
695 : ${KDE_DOC_DIRS:=doc}
696 local dir
697 for dir in ${KDE_DOC_DIRS}; do
698 sed -e "\!^[[:space:]]*add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
699 -e "\!^[[:space:]]*ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
700 -e "\!^[[:space:]]*macro_optional_add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
701 -e "\!^[[:space:]]*MACRO_OPTIONAL_ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
702 -i CMakeLists.txt || die "failed to comment out handbook"
703 done
704 fi
705 else
706 enable_selected_doc_linguas
707 fi
693 fi 708 fi
694 709
695 # SCM bootstrap 710 # SCM bootstrap
696 if [[ ${BUILD_TYPE} = live ]]; then 711 if [[ ${BUILD_TYPE} = live ]]; then
697 if has subversion ${INHERITED}; then 712 case ${KDE_SCM} in
698 subversion_src_prepare 713 svn) subversion_src_prepare ;;
699 elif has git ${INHERITED}; then 714 esac
700 git_src_prepare
701 fi
702 fi 715 fi
703 716
704 # Apply patches 717 # Apply patches
705 base_src_prepare 718 base_src_prepare
706 719
711 724
712 # Inject library dependencies 725 # Inject library dependencies
713 if [[ -n ${KMLOADLIBS} ]] ; then 726 if [[ -n ${KMLOADLIBS} ]] ; then
714 load_library_dependencies 727 load_library_dependencies
715 fi 728 fi
716
717 # Replace KDE4Workspace library targets
718 find "${S}" -name CMakeLists.txt \
719 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_TASKMANAGER_(LIBRARY|LIBS)\}/taskmanager/g' {} + \
720 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWORKSPACE_(LIBRARY|LIBS)\}/kworkspace/g' {} + \
721 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROLIFACES_(LIBRARY|LIBS)\}/solidcontrolifaces/g' {} + \
722 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROL_(LIBRARY|LIBS)\}/solidcontrol/g' {} + \
723 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PROCESSUI_(LIBRARY|LIBS)\}/processui/g' {} + \
724 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_LSOFUI_(LIBRARY|LIBS)\}/lsofui/g' {} + \
725 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PLASMACLOCK_(LIBRARY|LIBS)\}/plasmaclock/g' {} + \
726 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERYCLIENT_(LIBRARY|LIBS)\}/nepomukqueryclient/g' {} + \
727 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERY_(LIBRARY|LIBS)\}/nepomukquery/g' {} + \
728 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSCREENSAVER_(LIBRARY|LIBS)\}/kscreensaver/g' {} + \
729 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_WEATHERION_(LIBRARY|LIBS)\}/weather_ion/g' {} + \
730 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWINEFFECTS_(LIBRARY|LIBS)\}/kwineffects/g' {} + \
731 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KDECORATIONS_(LIBRARY|LIBS)\}/kdecorations/g' {} + \
732 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSGRD_(LIBRARY|LIBS)\}/ksgrd/g' {} + \
733 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KEPHAL_(LIBRARY|LIBS)\}/kephal/g' {} + \
734 || die 'failed to replace KDE4Workspace library targets'
735 729
736 # Hack for manuals relying on outdated DTD, only outside kde-base/koffice/... 730 # Hack for manuals relying on outdated DTD, only outside kde-base/koffice/...
737 if [[ -z ${KDEBASE} ]]; then 731 if [[ -z ${KDEBASE} ]]; then
738 find "${S}" -name "*.docbook" \ 732 find "${S}" -name "*.docbook" \
739 -exec sed -i -r \ 733 -exec sed -i -r \
749 debug-print-function ${FUNCNAME} "$@" 743 debug-print-function ${FUNCNAME} "$@"
750 744
751 # Build tests in src_test only, where we override this value 745 # Build tests in src_test only, where we override this value
752 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF) 746 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
753 747
754 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then 748 if use_if_iuse debug; then
755 cmakeargs+=(-DKDE4_ENABLE_FINAL=ON)
756 fi
757
758 if has debug ${IUSE//+} && use debug; then
759 # Set "real" debug mode 749 # Set "real" debug mode
760 CMAKE_BUILD_TYPE="Debugfull" 750 CMAKE_BUILD_TYPE="Debugfull"
761 else 751 else
762 # Handle common release builds 752 # Handle common release builds
763 append-cppflags -DQT_NO_DEBUG 753 append-cppflags -DQT_NO_DEBUG
770 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}") 760 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
771 761
772 # Use colors 762 # Use colors
773 QTEST_COLORED=1 763 QTEST_COLORED=1
774 764
775 # Shadow existing /usr installations 765 # Shadow existing installations
776 unset KDEDIRS 766 unset KDEDIRS
777 767
778 # Handle kdeprefix-ed KDE
779 if [[ ${KDEDIR} != /usr ]]; then
780 # Override some environment variables - only when kdeprefix is different,
781 # to not break ccache/distcc
782 PATH="${EKDEDIR}/bin:${PATH}"
783
784 # Append library search path
785 append-ldflags -L"${EKDEDIR}/$(get_libdir)"
786
787 # Append full RPATH
788 cmakeargs+=(-DCMAKE_SKIP_RPATH=OFF)
789
790 # Set cmake prefixes to allow buildsystem to locate valid KDE installation
791 # when more are present
792 cmakeargs+=(-DCMAKE_SYSTEM_PREFIX_PATH="${EKDEDIR}")
793 fi
794
795 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling 768 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
796 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/lib/qt4) 769 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4)
797 #kde-config -path data unavailable when cross-compiling 770 #kde-config -path data unavailable when cross-compiling
798 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/) 771 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
799 772
800 # Handle kdeprefix in application itself
801 if ! has kdeprefix ${IUSE//+} || ! use kdeprefix; then
802 # If prefix is /usr, sysconf needs to be /etc, not /usr/etc 773 # sysconf needs to be /etc, not /usr/etc
803 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc) 774 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
804 fi
805 775
806 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then 776 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
807 mycmakeargs=(${mycmakeargs}) 777 mycmakeargs=(${mycmakeargs})
808 fi 778 fi
809 779
830 # Override this value, set in kde4-base_src_configure() 800 # Override this value, set in kde4-base_src_configure()
831 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON) 801 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
832 cmake-utils_src_configure 802 cmake-utils_src_configure
833 kde4-base_src_compile 803 kde4-base_src_compile
834 804
835 if [[ ${VIRTUALX_REQUIRED} == always ]] || 805 # When run as normal user during ebuild development with the ebuild command, the
836 ( [[ ${VIRTUALX_REQUIRED} != manual ]] && use test ); then 806 # kde tests tend to access the session DBUS. This however is not possible in a real
807 # emerge or on the tinderbox.
808 # > make sure it does not happen, so bad tests can be recognized and disabled
809 unset DBUS_SESSION_BUS_ADDRESS
837 810
838 if [[ ${maketype} ]]; then 811 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then
812 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default
813 if [[ ${VIRTUALX_COMMAND} != emake ]]; then
839 # surprise- we are already INSIDE virtualmake!!! 814 # surprise- we are already INSIDE virtualmake!!!
840 ewarn "QA Notice: This version of kde4-base.eclass includes the virtualx functionality." 815 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
841 ewarn " You may NOT set maketype or call virtualmake from the ebuild. Applying workaround." 816 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild."
817 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the"
818 debug-print " kde4-base.eclass docs for details... Applying workaround."
842 cmake-utils_src_test 819 cmake-utils_src_test
843 else 820 else
844 export maketype="cmake-utils_src_test" 821 VIRTUALX_COMMAND="cmake-utils_src_test" virtualmake
845 virtualmake
846 fi 822 fi
847 else 823 else
848 cmake-utils_src_test 824 cmake-utils_src_test
849 fi 825 fi
850} 826}
852# @FUNCTION: kde4-base_src_install 828# @FUNCTION: kde4-base_src_install
853# @DESCRIPTION: 829# @DESCRIPTION:
854# Function for installing KDE4 applications. 830# Function for installing KDE4 applications.
855kde4-base_src_install() { 831kde4-base_src_install() {
856 debug-print-function ${FUNCNAME} "$@" 832 debug-print-function ${FUNCNAME} "$@"
857
858 # Prefix support, for usage in ebuilds
859 if [[ ${EAPI} == 2 ]] && ! use prefix; then
860 ED=${D}
861 fi
862 833
863 if [[ -n ${KMSAVELIBS} ]] ; then 834 if [[ -n ${KMSAVELIBS} ]] ; then
864 install_library_dependencies 835 install_library_dependencies
865 fi 836 fi
866 837
867 # Install common documentation of KDE4 applications 838 # Install common documentation of KDE4 applications
868 local doc 839 local doc
869 if ! has kde4-meta ${INHERITED}; then 840 if ! has kde4-meta ${INHERITED}; then
870 for doc in "${S}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do 841 for doc in "${S}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
871 [[ -f "${doc}" ]] && [[ -s "${doc}" ]] && dodoc "${doc}" 842 [[ -f ${doc} && -s ${doc} ]] && dodoc "${doc}"
872 done 843 done
873 for doc in "${S}"/*/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do 844 for doc in "${S}"/*/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
874 [[ -f "${doc}" ]] && [[ -s "${doc}" ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})" 845 [[ -f ${doc} && -s ${doc} ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})"
875 done 846 done
876 fi 847 fi
877 848
878 cmake-utils_src_install 849 cmake-utils_src_install
850
851 # In EAPI 4+, we don't want ${PREFIX}/share/doc/HTML to be compressed,
852 # because then khelpcenter can't find the docs
853 [[ ${EAPI:-0} != 3 && -d ${ED}/${PREFIX}/share/doc/HTML ]] &&
854 docompress -x ${PREFIX}/share/doc/HTML
855}
856
857# @FUNCTION: kde4-base_pkg_preinst
858# @DESCRIPTION:
859# Function storing icon caches
860kde4-base_pkg_preinst() {
861 debug-print-function ${FUNCNAME} "$@"
862
863 gnome2_icon_savelist
864 if [[ ${BUILD_TYPE} == live && ${KDE_SCM} == svn ]]; then
865 subversion_pkg_preinst
866 fi
879} 867}
880 868
881# @FUNCTION: kde4-base_pkg_postinst 869# @FUNCTION: kde4-base_pkg_postinst
882# @DESCRIPTION: 870# @DESCRIPTION:
883# Function to rebuild the KDE System Configuration Cache after an application has been installed. 871# Function to rebuild the KDE System Configuration Cache after an application has been installed.
884kde4-base_pkg_postinst() { 872kde4-base_pkg_postinst() {
885 debug-print-function ${FUNCNAME} "$@" 873 debug-print-function ${FUNCNAME} "$@"
886 874
875 gnome2_icon_cache_update
876 fdo-mime_desktop_database_update
877 fdo-mime_mime_database_update
887 buildsycoca 878 buildsycoca
888 879
889 if [[ ${BUILD_TYPE} = live ]] && [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then 880 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
890 echo 881 if [[ ${BUILD_TYPE} = live ]]; then
891 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
892 einfo "Use it at your own risk."
893 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
894 echo
895 elif [[ ${BUILD_TYPE} != live ]] && [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]] && has kdeprefix ${IUSE//+} && use kdeprefix; then
896 # warning about kdeprefix for non-live users
897 echo
898 ewarn "WARNING! You have the kdeprefix useflag enabled."
899 ewarn "This setting is strongly discouraged and might lead to potential trouble"
900 ewarn "with KDE update strategies."
901 ewarn "You are using this setup at your own risk and the kde team does not"
902 ewarn "take responsibilities for dead kittens."
903 echo
904 fi
905 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]] && ! has_version 'kde-base/kdebase-runtime-meta' && ! has_version 'kde-base/kdebase-startkde'; then
906 # warn about not supported approach
907 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
908 echo 882 echo
883 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
884 einfo "Use it at your own risk."
885 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
886 echo
887 fi
888 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta
889 if [[ ${KDEBASE} != kde-base ]] && \
890 ! has_version 'kde-base/kdebase-runtime-meta' && \
891 ! has_version 'kde-base/kdebase-startkde'; then
892 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
893 echo
909 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\"" 894 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\""
910 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above." 895 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above."
911 ewarn "With this setting you are unsupported by KDE team." 896 ewarn "With this setting you are unsupported by KDE team."
912 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID." 897 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID."
898 fi
913 fi 899 fi
914 fi 900 fi
915} 901}
916 902
917# @FUNCTION: kde4-base_pkg_postrm 903# @FUNCTION: kde4-base_pkg_postrm
918# @DESCRIPTION: 904# @DESCRIPTION:
919# Function to rebuild the KDE System Configuration Cache after an application has been removed. 905# Function to rebuild the KDE System Configuration Cache after an application has been removed.
920kde4-base_pkg_postrm() { 906kde4-base_pkg_postrm() {
921 debug-print-function ${FUNCNAME} "$@" 907 debug-print-function ${FUNCNAME} "$@"
922 908
909 gnome2_icon_cache_update
910 fdo-mime_desktop_database_update
911 fdo-mime_mime_database_update
923 buildsycoca 912 buildsycoca
924} 913}

Legend:
Removed from v.1.79  
changed lines
  Added in v.1.115

  ViewVC Help
Powered by ViewVC 1.1.20